diff --git a/gcc/m2/pge-boot/GDynamicStrings.h b/gcc/m2/pge-boot/GDynamicStrings.h
index 76f4cea6c81..e0652a7d3bd 100644
--- a/gcc/m2/pge-boot/GDynamicStrings.h
+++ b/gcc/m2/pge-boot/GDynamicStrings.h
@@ -194,12 +194,25 @@ EXTERN int DynamicStrings_Index (DynamicStrings_String s, char ch, unsigned int
 
 /*
    RIndex - returns the indice of the last occurance of, ch,
-            in String, s. The search starts at position, o.
-            -1 is returned if, ch, is not found.
+            in String, s.  The search starts at position, o.
+            -1 is returned if ch is not found.  The search
+            is performed left to right.
 */
 
 EXTERN int DynamicStrings_RIndex (DynamicStrings_String s, char ch, unsigned int o);
 
+/*
+   ReverseIndex - returns the indice of the last occurance of ch
+                  in String s.  The search starts at position o
+                  and searches from right to left.  The start position
+                  may be indexed negatively from the right (-1 is the
+                  last index).
+                  The return value if ch is found will always be positive.
+                  -1 is returned if ch is not found.
+*/
+
+EXTERN int DynamicStrings_ReverseIndex (DynamicStrings_String s, char ch, int o);
+
 /*
    RemoveComment - assuming that, comment, is a comment delimiter
                    which indicates anything to its right is a comment
diff --git a/gcc/m2/pge-boot/GM2RTS.h b/gcc/m2/pge-boot/GM2RTS.h
index 055cc95675b..4186c8f25e4 100644
--- a/gcc/m2/pge-boot/GM2RTS.h
+++ b/gcc/m2/pge-boot/GM2RTS.h
@@ -54,6 +54,11 @@ typedef struct M2RTS_ArgCVEnvP_p M2RTS_ArgCVEnvP;
 typedef void (*M2RTS_ArgCVEnvP_t) (int, void *, void *);
 struct M2RTS_ArgCVEnvP_p { M2RTS_ArgCVEnvP_t proc; };
 
+#define M2RTS_RegisterModule_Cstr(MODNAME,LIBNAME,init,fini,dep) \
+  M2RTS_RegisterModule (reinterpret_cast <void *> (const_cast <char *> (MODNAME)), \
+			reinterpret_cast <void *> (const_cast <char *> (LIBNAME)), \
+			init, fini, dep)
+
 EXTERN void M2RTS_ConstructModules (void * applicationmodule, void * libname, void * overrideliborder, int argc, void * argv, void * envp);
 EXTERN void M2RTS_DeconstructModules (void * applicationmodule, void * libname, int argc, void * argv, void * envp);
 
@@ -63,7 +68,10 @@ EXTERN void M2RTS_DeconstructModules (void * applicationmodule, void * libname,
                     explored to determine initialization order.
 */
 
-EXTERN void M2RTS_RegisterModule (void * name, void * libname, M2RTS_ArgCVEnvP init, M2RTS_ArgCVEnvP fini, PROC dependencies);
+EXTERN void M2RTS_RegisterModule (void *name, void *libname,
+				  M2RTS_ArgCVEnvP init,
+				  M2RTS_ArgCVEnvP fini,
+				  PROC dependencies);
 
 /*
    RequestDependant - used to specify that modulename is dependant upon
diff --git a/gcc/m2/pge-boot/GSymbolKey.cc b/gcc/m2/pge-boot/GSymbolKey.cc
index 5f22ae2be64..ec27e2c67b6 100644
--- a/gcc/m2/pge-boot/GSymbolKey.cc
+++ b/gcc/m2/pge-boot/GSymbolKey.cc
@@ -20,6 +20,8 @@ You should have received a copy of the GNU General Public License
 along with GNU Modula-2; see the file COPYING3.  If not see
 <http://www.gnu.org/licenses/>.  */
 
+#include "config.h"
+#include "system.h"
 #include <stdbool.h>
 #   if !defined (PROC_D)
 #      define PROC_D
@@ -31,15 +33,14 @@ along with GNU Modula-2; see the file COPYING3.  If not see
 #      define FALSE (1==0)
 #   endif
 
-#include <stddef.h>
 #   include "GStorage.h"
 #if defined(__cplusplus)
 #   undef NULL
 #   define NULL 0
 #endif
-#define _SymbolKey_H
 #define _SymbolKey_C
 
+#include "GSymbolKey.h"
 #   include "GStorage.h"
 #   include "GStrIO.h"
 #   include "GNumberIO.h"
@@ -54,19 +55,13 @@ typedef struct SymbolKey_PerformOperation_p SymbolKey_PerformOperation;
 
 typedef struct SymbolKey_Node_r SymbolKey_Node;
 
-typedef SymbolKey_Node *SymbolKey_SymbolTree;
-
-typedef bool (*SymbolKey_IsSymbol_t) (unsigned int);
-struct SymbolKey_IsSymbol_p { SymbolKey_IsSymbol_t proc; };
-
-typedef void (*SymbolKey_PerformOperation_t) (unsigned int);
-struct SymbolKey_PerformOperation_p { SymbolKey_PerformOperation_t proc; };
+typedef SymbolKey_Node *SymbolKey_SymbolTree__opaque;
 
 struct SymbolKey_Node_r {
                           NameKey_Name KeyName;
                           unsigned int KeySym;
-                          SymbolKey_SymbolTree Left;
-                          SymbolKey_SymbolTree Right;
+                          SymbolKey_SymbolTree__opaque Left;
+                          SymbolKey_SymbolTree__opaque Right;
                         };
 
 extern "C" void SymbolKey_InitTree (SymbolKey_SymbolTree *t);
@@ -142,7 +137,7 @@ extern "C" void SymbolKey_ForeachNodeConditionDo (SymbolKey_SymbolTree t, Symbol
                           if an entry is found, parent is set to the node above child.
 */
 
-static void FindNodeParentInTree (SymbolKey_SymbolTree t, NameKey_Name n, SymbolKey_SymbolTree *child, SymbolKey_SymbolTree *parent);
+static void FindNodeParentInTree (SymbolKey_SymbolTree__opaque t, NameKey_Name n, SymbolKey_SymbolTree__opaque *child, SymbolKey_SymbolTree__opaque *parent);
 
 /*
    SearchForAny - performs the search required for DoesTreeContainAny.
@@ -150,7 +145,7 @@ static void FindNodeParentInTree (SymbolKey_SymbolTree t, NameKey_Name n, Symbol
                   therefore we must skip over it.
 */
 
-static bool SearchForAny (SymbolKey_SymbolTree t, SymbolKey_IsSymbol P);
+static bool SearchForAny (SymbolKey_SymbolTree__opaque t, SymbolKey_IsSymbol P);
 
 /*
    SearchAndDo - searches all the nodes in SymbolTree, t, and
@@ -158,19 +153,19 @@ static bool SearchForAny (SymbolKey_SymbolTree t, SymbolKey_IsSymbol P);
                  It traverse the tree in order.
 */
 
-static void SearchAndDo (SymbolKey_SymbolTree t, SymbolKey_PerformOperation P);
+static void SearchAndDo (SymbolKey_SymbolTree__opaque t, SymbolKey_PerformOperation P);
 
 /*
    CountNodes - wrapper for NoOfNodes.
 */
 
-static unsigned int CountNodes (SymbolKey_SymbolTree t, SymbolKey_IsSymbol condition, unsigned int count);
+static unsigned int CountNodes (SymbolKey_SymbolTree__opaque t, SymbolKey_IsSymbol condition, unsigned int count);
 
 /*
    SearchConditional - wrapper for ForeachNodeConditionDo.
 */
 
-static void SearchConditional (SymbolKey_SymbolTree t, SymbolKey_IsSymbol condition, SymbolKey_PerformOperation P);
+static void SearchConditional (SymbolKey_SymbolTree__opaque t, SymbolKey_IsSymbol condition, SymbolKey_PerformOperation P);
 
 
 /*
@@ -178,7 +173,7 @@ static void SearchConditional (SymbolKey_SymbolTree t, SymbolKey_IsSymbol condit
                           if an entry is found, parent is set to the node above child.
 */
 
-static void FindNodeParentInTree (SymbolKey_SymbolTree t, NameKey_Name n, SymbolKey_SymbolTree *child, SymbolKey_SymbolTree *parent)
+static void FindNodeParentInTree (SymbolKey_SymbolTree__opaque t, NameKey_Name n, SymbolKey_SymbolTree__opaque *child, SymbolKey_SymbolTree__opaque *parent)
 {
   /* remember to skip the sentinal value and assign parent and child  */
   (*parent) = t;
@@ -213,7 +208,7 @@ static void FindNodeParentInTree (SymbolKey_SymbolTree t, NameKey_Name n, Symbol
                   therefore we must skip over it.
 */
 
-static bool SearchForAny (SymbolKey_SymbolTree t, SymbolKey_IsSymbol P)
+static bool SearchForAny (SymbolKey_SymbolTree__opaque t, SymbolKey_IsSymbol P)
 {
   if (t == NULL)
     {
@@ -234,7 +229,7 @@ static bool SearchForAny (SymbolKey_SymbolTree t, SymbolKey_IsSymbol P)
                  It traverse the tree in order.
 */
 
-static void SearchAndDo (SymbolKey_SymbolTree t, SymbolKey_PerformOperation P)
+static void SearchAndDo (SymbolKey_SymbolTree__opaque t, SymbolKey_PerformOperation P)
 {
   if (t != NULL)
     {
@@ -249,7 +244,7 @@ static void SearchAndDo (SymbolKey_SymbolTree t, SymbolKey_PerformOperation P)
    CountNodes - wrapper for NoOfNodes.
 */
 
-static unsigned int CountNodes (SymbolKey_SymbolTree t, SymbolKey_IsSymbol condition, unsigned int count)
+static unsigned int CountNodes (SymbolKey_SymbolTree__opaque t, SymbolKey_IsSymbol condition, unsigned int count)
 {
   if (t != NULL)
     {
@@ -270,7 +265,7 @@ static unsigned int CountNodes (SymbolKey_SymbolTree t, SymbolKey_IsSymbol condi
    SearchConditional - wrapper for ForeachNodeConditionDo.
 */
 
-static void SearchConditional (SymbolKey_SymbolTree t, SymbolKey_IsSymbol condition, SymbolKey_PerformOperation P)
+static void SearchConditional (SymbolKey_SymbolTree__opaque t, SymbolKey_IsSymbol condition, SymbolKey_PerformOperation P)
 {
   if (t != NULL)
     {
@@ -286,8 +281,8 @@ static void SearchConditional (SymbolKey_SymbolTree t, SymbolKey_IsSymbol condit
 extern "C" void SymbolKey_InitTree (SymbolKey_SymbolTree *t)
 {
   Storage_ALLOCATE ((void **) &(*t), sizeof (SymbolKey_Node));  /* The value entity  */
-  (*t)->Left = NULL;
-  (*t)->Right = NULL;
+  static_cast<SymbolKey_SymbolTree__opaque> ((*t))->Left = static_cast<SymbolKey_SymbolTree__opaque> (NULL);
+  static_cast<SymbolKey_SymbolTree__opaque> ((*t))->Right = static_cast<SymbolKey_SymbolTree__opaque> (NULL);
 }
 
 extern "C" void SymbolKey_KillTree (SymbolKey_SymbolTree *t)
@@ -322,10 +317,10 @@ END Kill ;
   */
   if ((*t) != NULL)
     {
-      SymbolKey_KillTree (&(*t)->Left);
-      SymbolKey_KillTree (&(*t)->Right);
+      SymbolKey_KillTree (reinterpret_cast<SymbolKey_SymbolTree *> (&static_cast<SymbolKey_SymbolTree__opaque> ((*t))->Left));
+      SymbolKey_KillTree (reinterpret_cast<SymbolKey_SymbolTree *> (&static_cast<SymbolKey_SymbolTree__opaque> ((*t))->Right));
       Storage_DEALLOCATE ((void **) &(*t), sizeof (SymbolKey_Node));
-      (*t) = NULL;
+      (*t) = static_cast<SymbolKey_SymbolTree> (NULL);
     }
 }
 
@@ -336,10 +331,10 @@ END Kill ;
 
 extern "C" unsigned int SymbolKey_GetSymKey (SymbolKey_SymbolTree t, NameKey_Name NameKey)
 {
-  SymbolKey_SymbolTree father;
-  SymbolKey_SymbolTree child;
+  SymbolKey_SymbolTree__opaque father;
+  SymbolKey_SymbolTree__opaque child;
 
-  FindNodeParentInTree (t, NameKey, &child, &father);
+  FindNodeParentInTree (static_cast<SymbolKey_SymbolTree__opaque> (t), NameKey, &child, &father);
   if (child == NULL)
     {
       return static_cast<unsigned int> (SymbolKey_NulKey);
@@ -359,10 +354,10 @@ extern "C" unsigned int SymbolKey_GetSymKey (SymbolKey_SymbolTree t, NameKey_Nam
 
 extern "C" void SymbolKey_PutSymKey (SymbolKey_SymbolTree t, NameKey_Name NameKey, unsigned int SymKey)
 {
-  SymbolKey_SymbolTree father;
-  SymbolKey_SymbolTree child;
+  SymbolKey_SymbolTree__opaque father;
+  SymbolKey_SymbolTree__opaque child;
 
-  FindNodeParentInTree (t, NameKey, &child, &father);
+  FindNodeParentInTree (static_cast<SymbolKey_SymbolTree__opaque> (t), NameKey, &child, &father);
   if (child == NULL)
     {
       /* no child found, now is NameKey less than father or greater?  */
@@ -386,8 +381,8 @@ extern "C" void SymbolKey_PutSymKey (SymbolKey_SymbolTree t, NameKey_Name NameKe
               father->Right = child;
             }
         }
-      child->Right = NULL;
-      child->Left = NULL;
+      child->Right = static_cast<SymbolKey_SymbolTree__opaque> (NULL);
+      child->Left = static_cast<SymbolKey_SymbolTree__opaque> (NULL);
       child->KeySym = SymKey;
       child->KeyName = NameKey;
     }
@@ -407,11 +402,11 @@ extern "C" void SymbolKey_PutSymKey (SymbolKey_SymbolTree t, NameKey_Name NameKe
 
 extern "C" void SymbolKey_DelSymKey (SymbolKey_SymbolTree t, NameKey_Name NameKey)
 {
-  SymbolKey_SymbolTree i;
-  SymbolKey_SymbolTree child;
-  SymbolKey_SymbolTree father;
+  SymbolKey_SymbolTree__opaque i;
+  SymbolKey_SymbolTree__opaque child;
+  SymbolKey_SymbolTree__opaque father;
 
-  FindNodeParentInTree (t, NameKey, &child, &father);  /* find father and child of the node  */
+  FindNodeParentInTree (static_cast<SymbolKey_SymbolTree__opaque> (t), NameKey, &child, &father);  /* find father and child of the node  */
   if ((child != NULL) && (child->KeyName == NameKey))
     {
       /* Have found the node to be deleted  */
@@ -471,7 +466,7 @@ extern "C" void SymbolKey_DelSymKey (SymbolKey_SymbolTree t, NameKey_Name NameKe
 
 extern "C" bool SymbolKey_IsEmptyTree (SymbolKey_SymbolTree t)
 {
-  return t->Left == NULL;
+  return static_cast<SymbolKey_SymbolTree__opaque> (t)->Left == NULL;
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -487,7 +482,7 @@ extern "C" bool SymbolKey_IsEmptyTree (SymbolKey_SymbolTree t)
 
 extern "C" bool SymbolKey_DoesTreeContainAny (SymbolKey_SymbolTree t, SymbolKey_IsSymbol P)
 {
-  return SearchForAny (t->Left, P);
+  return SearchForAny (static_cast<SymbolKey_SymbolTree__opaque> (t)->Left, P);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -502,7 +497,7 @@ extern "C" bool SymbolKey_DoesTreeContainAny (SymbolKey_SymbolTree t, SymbolKey_
 
 extern "C" void SymbolKey_ForeachNodeDo (SymbolKey_SymbolTree t, SymbolKey_PerformOperation P)
 {
-  SearchAndDo (t->Left, P);
+  SearchAndDo (static_cast<SymbolKey_SymbolTree__opaque> (t)->Left, P);
 }
 
 
@@ -512,10 +507,10 @@ extern "C" void SymbolKey_ForeachNodeDo (SymbolKey_SymbolTree t, SymbolKey_Perfo
 
 extern "C" bool SymbolKey_ContainsSymKey (SymbolKey_SymbolTree t, NameKey_Name NameKey)
 {
-  SymbolKey_SymbolTree father;
-  SymbolKey_SymbolTree child;
+  SymbolKey_SymbolTree__opaque father;
+  SymbolKey_SymbolTree__opaque child;
 
-  FindNodeParentInTree (t, NameKey, &child, &father);
+  FindNodeParentInTree (static_cast<SymbolKey_SymbolTree__opaque> (t), NameKey, &child, &father);
   return child != NULL;
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
@@ -528,7 +523,7 @@ extern "C" bool SymbolKey_ContainsSymKey (SymbolKey_SymbolTree t, NameKey_Name N
 
 extern "C" unsigned int SymbolKey_NoOfNodes (SymbolKey_SymbolTree t, SymbolKey_IsSymbol condition)
 {
-  return CountNodes (t->Left, condition, 0);
+  return CountNodes (static_cast<SymbolKey_SymbolTree__opaque> (t)->Left, condition, 0);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -543,15 +538,15 @@ extern "C" void SymbolKey_ForeachNodeConditionDo (SymbolKey_SymbolTree t, Symbol
 {
   if (t != NULL)
     {
-      Assertion_Assert (t->Right == NULL);
-      SearchConditional (t->Left, condition, P);
+      Assertion_Assert (static_cast<SymbolKey_SymbolTree__opaque> (t)->Right == NULL);
+      SearchConditional (static_cast<SymbolKey_SymbolTree__opaque> (t)->Left, condition, P);
     }
 }
 
-extern "C" void _M2_SymbolKey_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_SymbolKey_init (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
 
-extern "C" void _M2_SymbolKey_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_SymbolKey_fini (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
diff --git a/gcc/m2/pge-boot/GSysExceptions.cc b/gcc/m2/pge-boot/GSysExceptions.cc
index dee36f981ce..d16197dbcc7 100644
--- a/gcc/m2/pge-boot/GSysExceptions.cc
+++ b/gcc/m2/pge-boot/GSysExceptions.cc
@@ -226,12 +226,12 @@ SysExceptions_InitExceptionHandlers (void *indexf, void *range, void *casef,
 
 EXTERN
 void
-_M2_SysExceptions_init (void)
+_M2_SysExceptions_init (int argc, char *argv[], char *envp[])
 {
 }
 
 EXTERN
 void
-_M2_SysExceptions_fini (void)
+_M2_SysExceptions_fini (int argc, char *argv[], char *envp[])
 {
 }
diff --git a/gcc/m2/pge-boot/GUnixArgs.cc b/gcc/m2/pge-boot/GUnixArgs.cc
index 02d0df3dff8..cab9f7a9dea 100644
--- a/gcc/m2/pge-boot/GUnixArgs.cc
+++ b/gcc/m2/pge-boot/GUnixArgs.cc
@@ -88,6 +88,6 @@ struct _M2_UnixArgs_ctor { _M2_UnixArgs_ctor (); } _M2_UnixArgs_ctor;
 
 _M2_UnixArgs_ctor::_M2_UnixArgs_ctor (void)
 {
-  M2RTS_RegisterModule ("UnixArgs", LIBNAME, _M2_UnixArgs_init, _M2_UnixArgs_fini,
-			_M2_UnixArgs_dep);
+  M2RTS_RegisterModule_Cstr ("UnixArgs", LIBNAME, _M2_UnixArgs_init,
+			     _M2_UnixArgs_fini, _M2_UnixArgs_dep);
 }
diff --git a/gcc/m2/pge-boot/Gerrno.cc b/gcc/m2/pge-boot/Gerrno.cc
index d51a619baef..ca4e23272ed 100644
--- a/gcc/m2/pge-boot/Gerrno.cc
+++ b/gcc/m2/pge-boot/Gerrno.cc
@@ -38,14 +38,14 @@ errno_geterrno (void)
 /* init constructor for the module.  */
 
 void
-_M2_errno_init (int argc, char *p)
+_M2_errno_init (int argc, char *argv[], char *envp[])
 {
 }
 
 /* finish deconstructor for the module.  */
 
 void
-_M2_errno_fini (int argc, char *p)
+_M2_errno_fini (int argc, char *argv[], char *envp[])
 {
 }
 
diff --git a/gcc/m2/pge-boot/Gldtoa.cc b/gcc/m2/pge-boot/Gldtoa.cc
index c1a74505f13..a3ae3960a91 100644
--- a/gcc/m2/pge-boot/Gldtoa.cc
+++ b/gcc/m2/pge-boot/Gldtoa.cc
@@ -43,22 +43,22 @@ extern int dtoa_calcsign (char *p, int str_size);
    (ndigits may be negative).  */
 
 long double
-ldtoa_strtold (const char *s, int *error)
+ldtoa_strtold (void *s, bool *error)
 {
   char *endp;
   long double d;
 
   errno = 0;
 #if defined(HAVE_STRTOLD)
-  d = strtold (s, &endp);
+  d = strtold (reinterpret_cast <char *> (s), &endp);
 #else
   /* fall back to using strtod.  */
-  d = (long double)strtod (s, &endp);
+  d = (long double) strtod (reinterpret_cast <char *> (s), &endp);
 #endif
   if (endp != NULL && (*endp == '\0'))
     *error = (errno != 0);
   else
-    *error = TRUE;
+    *error = true;
   return d;
 }
 
diff --git a/gcc/m2/pge-boot/Glibc.cc b/gcc/m2/pge-boot/Glibc.cc
index abeb56a3b01..a63b328ed60 100644
--- a/gcc/m2/pge-boot/Glibc.cc
+++ b/gcc/m2/pge-boot/Glibc.cc
@@ -29,15 +29,15 @@ along with GNU Modula-2; see the file COPYING3.  If not see
 #endif
 
 EXTERN
-int
-libc_read (int fd, void *a, int nbytes)
+size_t
+libc_read (int fd, void *a, size_t nbytes)
 {
   return read (fd, a, nbytes);
 }
 
 EXTERN
-int
-libc_write (int fd, void *a, int nbytes)
+size_t
+libc_write (int fd, void *a, size_t nbytes)
 {
   return write (fd, a, nbytes);
 }
@@ -58,7 +58,7 @@ libc_exit (int code)
 
 EXTERN
 void
-libc_perror (char *s)
+libc_perror (const char *s)
 {
   perror (s);
 }
@@ -71,7 +71,7 @@ libc_abort ()
 }
 
 EXTERN
-int
+size_t
 libc_strlen (char *s)
 {
   return strlen (s);
@@ -79,7 +79,7 @@ libc_strlen (char *s)
 
 EXTERN
 int
-libc_printf (char *_format, unsigned int _format_high, ...)
+libc_printf (const char *_format, unsigned int _format_high, ...)
 {
   va_list arg;
   int done;
@@ -90,7 +90,7 @@ libc_printf (char *_format, unsigned int _format_high, ...)
 
   do
     {
-      c = index (&_format[i], '\\');
+      c = index (&const_cast <char *> (_format)[i], '\\');
       if (c == NULL)
         strcpy (&format[j], &_format[i]);
       else
@@ -117,7 +117,7 @@ libc_printf (char *_format, unsigned int _format_high, ...)
 
 EXTERN
 int
-libc_snprintf (char *dest, size_t length, char *_format, unsigned int _format_high, ...)
+libc_snprintf (void *dest, size_t length, const char *_format, unsigned int _format_high, ...)
 {
   va_list arg;
   int done;
@@ -128,7 +128,7 @@ libc_snprintf (char *dest, size_t length, char *_format, unsigned int _format_hi
 
   do
     {
-      c = index (&_format[i], '\\');
+      c = index (&const_cast <char *> (_format)[i], '\\');
       if (c == NULL)
         strcpy (&format[j], &_format[i]);
       else
@@ -147,14 +147,14 @@ libc_snprintf (char *dest, size_t length, char *_format, unsigned int _format_hi
   while (c != NULL);
 
   va_start (arg, _format_high);
-  done = vsnprintf (dest, length, format, arg);
+  done = vsnprintf (reinterpret_cast<char *> (dest), length, format, arg);
   va_end (arg);
   return done;
 }
 
 EXTERN
 void *
-libc_malloc (unsigned int size)
+libc_malloc (size_t size)
 {
   return malloc (size);
 }
@@ -196,9 +196,9 @@ libc_system (char *command)
 
 EXTERN
 void *
-libc_memcpy (void *dest, void *src, int n)
+libc_memcpy (void *dest, void *src, size_t nbytes)
 {
-  return memcpy (dest, src, n);
+  return memcpy (dest, src, nbytes);
 }
 
 EXTERN
@@ -224,9 +224,14 @@ libc_creat (char *p, mode_t mode)
 
 EXTERN
 int
-libc_open (char *p, int flags, mode_t mode)
+libc_open (void *p, int oflag, ...)
 {
-  return open (p, flags, mode);
+  va_list arg;
+  va_start (arg, oflag);
+  mode_t mode = va_arg (arg, mode_t);
+  int result = open (reinterpret_cast <char *> (p), oflag, mode);
+  va_end (arg);
+  return result;
 }
 
 EXTERN
diff --git a/gcc/m2/pge-boot/Glibc.h b/gcc/m2/pge-boot/Glibc.h
index 382b737e4b8..a5558932348 100644
--- a/gcc/m2/pge-boot/Glibc.h
+++ b/gcc/m2/pge-boot/Glibc.h
@@ -198,7 +198,7 @@ EXTERN ssize_t libc_lseek (int fd, ssize_t offset, int whence);
    perror - writes errno and string. (ARRAY OF CHAR is translated onto ADDRESS).
 */
 
-EXTERN void libc_perror (const char *string_, unsigned int _string_high);
+EXTERN void libc_perror (const char *str);
 
 /*
    readv - reads an io vector of bytes.
